﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

using iTextSharp;
using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.text.factories;
using iTextSharp.text.pdf.parser;

using System.IO;
using System.Collections;
using System.Windows.Forms;

using FreeImageAPI;

/*1
using PdfSharp.Drawing;
using PdfSharp.Pdf;
using PdfSharp.Pdf.IO;
using PdfSharp.Pdf.Advanced;
using PdfSharp.Pdf.Security;
*/


namespace PDFUtilities
{
    class CompressPDFHelper
    {
        public static string CompressDecompressSinglePDF(string InputFile, string OutputFile, string Password, bool CompressImages, int ImageQuality)
        {
            string err = "";

            try
            {
                //                using (FileStream input = new FileStream(InputFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                //{
                PdfReader reader = null;
                string OutputFile2 = "";                

                try
                {
                    //  reader = new PdfReader(input);

                    using (Stream input = new FileStream(InputFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                    {
                        try
                        {
                            if (!String.IsNullOrEmpty(Password))
                            {
                                reader = new PdfReader(input, Encoding.Default.GetBytes(Password));
                                //reader = new PdfReader(input, Encoding.UTF8.GetBytes(Password));

                            }
                            else
                            {
                                reader = new PdfReader(input);
                            }
                        }
                        catch (iTextSharp.text.pdf.BadPasswordException ex)
                        {
                            if (reader != null)
                            {
                                reader.Close();
                            }

                            if (input != null)
                            {
                                input.Close();
                            }



                            err += "Error. Wrong User Password for File" + " : " + System.IO.Path.GetFileName(InputFile);

                            return err;
                        }
                    }

                    // do stuff
                    

                    //if ((Module.IsCommandLine && Module.CmdCompress) || (!Module.IsCommandLine && frmMain.Instance.rdCompress.Checked))
                    //{                    
                    /*
                    using (Stream input = new FileStream(InputFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                    {
                        try
                        {
                            if (!String.IsNullOrEmpty(Password))
                            {
                                reader2 = new PdfReader(input, Encoding.Default.GetBytes(Password));
                            }
                            else
                            {
                                reader2 = new PdfReader(input);
                            }

                                
                        }
                        catch (Exception exr2)
                        {
                            err += "Error. Could not read PDF File !" + exr2.Message + "\n\n";
                        }
                    }
                    */

                    /*
                    using (MemoryStream ms = new MemoryStream())
                    {
                        using (PdfStamper stamper = new PdfStamper(reader2, ms))
                        {
                            stamper.Writer.CompressionLevel = 9;
                            stamper.SetFullCompression();
                            stamper.FormFlattening = true;

                            stamper.Close();
                        }


                        File.WriteAllBytes(OutputFileRedu, ms.ToArray());
                    }

                    reader2.Close();
                    */

                    if (CompressImages)
                    {
                        ReduceResolution(reader, (long)ImageQuality);
                    }

                    OutputFile2 = OutputFile + ".temp.pdf";                    

                    using (MemoryStream memoryStream = new MemoryStream())
                    {
                        PdfStamper stamper = new PdfStamper(reader, memoryStream, PdfWriter.VERSION_1_5);
                        stamper.Writer.CompressionLevel = 9;

                        stamper.FormFlattening = true;
                        stamper.SetFullCompression();

                        int total = reader.NumberOfPages + 1;
                        for (int i = 1; i < total; i++)
                        {                            
                            //c                            
                            reader.SetPageContent(i, reader.GetPageContent(i));
                        }
                        stamper.SetFullCompression();
                        stamper.Close();
                        reader.Close();

                        File.WriteAllBytes(OutputFile2, memoryStream.ToArray());
                    }                    

                    //return err;

                    using (Stream input = new FileStream(OutputFile2, FileMode.Open, FileAccess.Read, FileShare.Read))
                    {
                        try
                        {
                            if (!String.IsNullOrEmpty(Password))
                            {
                                reader = new PdfReader(input, Encoding.Default.GetBytes(Password));
                            }
                            else
                            {
                                reader = new PdfReader(input);
                            }
                        }
                        catch (Exception exr2)
                        {
                            err += "Error. Could not read PDF File ! " + System.IO.Path.GetFileName(OutputFile2) + " " + exr2.Message + "\n\n";
                        }
                    }

                    //c                    

                    using (Stream outputPdfStream = new FileStream(OutputFile, FileMode.Create, FileAccess.Write, FileShare.None))
                    {
                        Document document = new Document();
                        PdfSmartCopy copy = new PdfSmartCopy(document, outputPdfStream);
                        copy.CompressionLevel = 9;
                        copy.SetFullCompression();
                        try
                        {
                            reader.RemoveUnusedObjects();
                        }
                        catch { }

                        document.Open();

                        int totalPageCnt = reader.NumberOfPages;

                        for (int t = 1; t <= totalPageCnt; t++)
                        {                            
                            //c                            
                            copy.AddPage(copy.GetImportedPage(reader, t));
                        }

                        copy.FreeReader(reader);
                        reader.Close();
                        copy.Close();
                        document.Close();

                    }
                    /*
                    }
                    else
                    {
                        using (MemoryStream memoryStream = new MemoryStream())
                        {                                                        
                            PdfStamper stamper = new PdfStamper(reader, memoryStream);
                            Document.Compress = false;

                            int total = reader.NumberOfPages + 1;
                            for (int i = 1; i < total; i++)
                            {
                                reader.SetPageContent(i, reader.GetPageContent(i));
                            }

                            stamper.Close();
                            reader.Close();

                            File.WriteAllBytes(OutputFile, memoryStream.ToArray());
                        }

                        Document.Compress = true;
                    }
                    */
                    /*
                        using (MemoryStream memoryStream = new MemoryStream())
                        {
                            PdfStamper stamper = new PdfStamper(reader, memoryStream);
                            if (dict.Count > 0)
                            {
                                stamper.MoreInfo = dict;
                            }

                            stamper.Close();
                            reader.Close();

                            File.WriteAllBytes(OutputFile, memoryStream.ToArray());
                        }
                    */                                                            

                    return err;
                }
                catch (Exception exm)
                {
                    err += "An error occured while compressiing PDF File" + " : " + System.IO.Path.GetFileName(InputFile) + "\r\n" + exm.Message + "\r\n";
                }
                finally
                {
                    if (reader != null)
                    {
                        reader.Close();
                    }

                    if (System.IO.File.Exists(OutputFile2))
                    {
                        try
                        {
                            System.IO.File.Delete(OutputFile2);
                        }
                        catch { }
                    }
                }
            }
            catch (Exception ex)
            {
                err += "An error occured while compressing PDF File" + " : " + InputFile + "\r\n" + ex.Message + "\r\n";
            }

            return err;
        }

        public static void ReduceResolution(PdfReader reader, long quality)
        {
            int n = reader.XrefSize;
            for (int i = 0; i < n; i++)
            {                
                PdfObject obj = reader.GetPdfObject(i);
                if (obj == null || !obj.IsStream()) { continue; }

                PdfDictionary dict = (PdfDictionary)PdfReader.GetPdfObject(obj);
                PdfName subType = (PdfName)PdfReader.GetPdfObject(
                  dict.Get(PdfName.SUBTYPE)
                );
                if (!PdfName.IMAGE.Equals(subType)) { continue; }

                PRStream stream = (PRStream)obj;
                try
                {
                    PdfImageObject image = new PdfImageObject(stream);
                    PdfName filter = (PdfName)image.Get(PdfName.FILTER);
                    if (
                      PdfName.JBIG2DECODE.Equals(filter)
                      || PdfName.JPXDECODE.Equals(filter)
                      || PdfName.CCITTFAXDECODE.Equals(filter)
                      || PdfName.FLATEDECODE.Equals(filter)
                    ) continue;

                    System.Drawing.Image img = image.GetDrawingImage();
                    if (img == null) continue;

                    var ll = image.GetImageBytesType();
                    int width = img.Width;
                    int height = img.Height;
                    using (System.Drawing.Bitmap dotnetImg =
                       new System.Drawing.Bitmap(img))
                    {
                        // set codec to jpeg type => jpeg index codec is "1"
                        System.Drawing.Imaging.ImageCodecInfo codec =
                        System.Drawing.Imaging.ImageCodecInfo.GetImageEncoders()[1];
                        // set parameters for image quality
                        System.Drawing.Imaging.EncoderParameters eParams =
                         new System.Drawing.Imaging.EncoderParameters(1);
                        eParams.Param[0] =
                         new System.Drawing.Imaging.EncoderParameter(
                           System.Drawing.Imaging.Encoder.Quality, quality
                        );
                        using (MemoryStream msImg = new MemoryStream())
                        {
                            dotnetImg.Save(msImg, codec, eParams);
                            msImg.Position = 0;
                            stream.SetData(msImg.ToArray());
                            stream.SetData(
                             msImg.ToArray(), false, PRStream.BEST_COMPRESSION
                            );
                            stream.Put(PdfName.TYPE, PdfName.XOBJECT);
                            stream.Put(PdfName.SUBTYPE, PdfName.IMAGE);
                            stream.Put(PdfName.FILTER, filter);
                            stream.Put(PdfName.FILTER, PdfName.DCTDECODE);
                            stream.Put(PdfName.WIDTH, new PdfNumber(width));
                            stream.Put(PdfName.HEIGHT, new PdfNumber(height));
                            stream.Put(PdfName.BITSPERCOMPONENT, new PdfNumber(8));
                            stream.Put(PdfName.COLORSPACE, PdfName.DEVICERGB);
                        }
                    }
                }
                catch
                {
                    // throw;
                    // iText[Sharp] can't handle all image types...
                }
                finally
                {
                    // may or may not help      
                    reader.RemoveUnusedObjects();
                }
            }
        }
    }
}
