﻿using System;
using System.Collections.Generic;
using System.Text;

namespace PDFUtilities
{
    class Program
    {
        static void Main(string[] args)
        {
            /*
            System.Diagnostics.Process[] procs = System.Diagnostics.Process.GetProcessesByName("pdfutilitiesnew");

            for (int k = 0; k < procs.Length; k++)
            {
                try
                {
                    procs[k].Kill();
                }
                catch { }
            }
            */

            args=RemoveQuotes(args);

            string inputFile = args[0];
            string outputFile = args[1];

            string function = args[2];

            if (function == "/compress")
            {
                bool compressImages = args[3].ToLower() == "true";

                int imageCompressionPerc = int.Parse(args[4]);

                string password = "";

                if (args.Length >= 6)
                {
                    password = args[5];
                }

                string err = CompressPDFHelper.CompressDecompressSinglePDF(
                    inputFile, outputFile, password, compressImages, imageCompressionPerc);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (function == "/protect")
            {
                EncryptArgs enc = new EncryptArgs();

                string userp = args[3];

                if (userp == "")
                {
                    userp = null;
                }

                enc.txtUserPassword = userp;

                string ownerp = args[4];
                if (ownerp == "")
                {
                    ownerp = null;
                }

                enc.txtOwnerPassword = ownerp;

                enc.chkAnnotations = args[5] == bool.TrueString;
                enc.chkAssembly = args[6] == bool.TrueString;
                enc.chkCopy = args[7] == bool.TrueString;
                enc.chkFormFill = args[8] == bool.TrueString;
                enc.chkHighPrinting = args[9] == bool.TrueString;
                enc.chkLowPrinting = args[10] == bool.TrueString;
                enc.chkModifyContents = args[11] == bool.TrueString;
                enc.chkScreenReaders = args[12] == bool.TrueString;
                enc.rd128Bits = args[13] == bool.TrueString;

                string existingPassword=args[14];

                string err = EncryptPDFHelper.EncryptSinglePDF(inputFile, outputFile, existingPassword, enc);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }

            }
            else if (function == "/extractimages")
            {                
                string password = args[3];

                if (password == string.Empty)
                {
                    password = null;
                }

                bool allPages = args[4] == bool.TrueString;

                string pageRanges = args[5];

                bool pagesEvery = args[6] == bool.TrueString;

                int pagesEveryValue = int.Parse(args[7]);

                bool oddPages = args[8] == bool.TrueString;

                bool evenPages = args[9] == bool.TrueString;

                bool containingText = args[10] == bool.TrueString;

                string textToContain = args[11];

                string err = PDFImageExtractor.ExtractImages(inputFile, outputFile, password, allPages, pageRanges, pagesEvery, pagesEveryValue,
                    oddPages, evenPages, containingText, textToContain);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
        }

        public static string[] RemoveQuotes(string[] args)
        {
            for (int k = 0; k < args.Length; k++)
            {
                if (args[k].StartsWith("\"") && args[k].EndsWith("\""))
                {
                    if (args[k].Length > 2)
                    {
                        args[k] = args[k].Substring(1, args.Length - 2);
                    }
                    else
                    {
                        args[k] = "";
                    }
                }
                else if (args[k].StartsWith("'") && args[k].EndsWith("'"))
                {
                    if (args[k].Length > 2)
                    {
                        args[k] = args[k].Substring(1, args.Length - 2);
                    }
                    else
                    {
                        args[k] = "";
                    }
                }
            }

            return args;
        }
    }
}
