﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using iTextSharp.text.pdf;
using iTextSharp.text.pdf.parser;
using iTextSharp.text;

namespace PDFUtilitiesNew
{
    class EmptyPDFPageChecker
    {
        public static bool IsPDFPageEmpty(PdfReader reader, int pageNumber)
        {
            PdfDictionary pageDict = reader.GetPageN(pageNumber);

            // We need to examine the resource dictionary for /Font or
            // /XObject keys.  If either are present, they're almost
            // certainly actually used on the page -> not blank.
            PdfDictionary resDict = (PdfDictionary)pageDict.Get(PdfName.RESOURCES);
            if (resDict != null)
            {
                string txt = iTextSharp.text.pdf.parser.PdfTextExtractor.GetTextFromPage(reader, pageNumber);

                if (txt != null)
                {
                    txt = txt.Trim();
                }

                bool noTextOrImages = string.IsNullOrEmpty(txt) && resDict.Get(PdfName.XOBJECT) == null;

                return noTextOrImages;
            }
             
            return false;
        }                                
    }
}
