﻿using System;
using System.Collections.Generic;
using System.Text;
using iTextSharp.text;
using iTextSharp.text.html.simpleparser;
using iTextSharp.text.pdf;
using System.IO;

namespace PDFUtilitiesNew
{
    class HTMLToPDFConverter
    {
        public static string ConvertHTMLToPDF(string filepath, string outputFile)
        {
            try
            {
                using (StringReader sr = new StringReader(System.IO.File.ReadAllText(filepath)))
                {
                    Document pdfDoc = new Document(PageSize.A4, 10f, 10f, 10f, 0f);
                    HTMLWorker htmlparser = new HTMLWorker(pdfDoc);
                    using (MemoryStream memoryStream = new MemoryStream())
                    {
                        PdfWriter writer = PdfWriter.GetInstance(pdfDoc, memoryStream);
                        pdfDoc.Open();

                        htmlparser.Parse(sr);
                        pdfDoc.Close();

                        byte[] bytes = memoryStream.ToArray();
                        memoryStream.Close();

                        System.IO.File.WriteAllBytes(outputFile, bytes);
                    }
                }

                return "";
            }
            catch (Exception ex)
            {
                return "Error-Count not Convert HTML to PDF " + System.IO.Path.GetFileName(filepath) + " " + ex.Message;
            }
        }
    }
}
