﻿using System;
using System.Collections.Generic;
using System.Text;
using iTextSharp.text.pdf;
using iTextSharp.text.pdf.parser;
using iTextSharp.text;
using System.Data;
using System.IO;

namespace PDFUtilitiesNew
{
    class ImageToPDFConverter
    {
        public static string ConvertImageToPDF(string outputFilepath,
            int pageSize, int orientation, int margin, int alignment, List<string> lstImages)
        {
            try
            {
                using (FileStream fs = new FileStream(outputFilepath, FileMode.Create, FileAccess.Write, FileShare.None))
                {
                    //using (Document doc = new Document())
                    //{

                    Document doc = null;

                    int imargin = 0;

                    if (margin == 2)
                    {
                        imargin = 0;
                    }
                    else if (margin == 0)
                    {
                        imargin = 10;
                    }
                    else if (margin == 1)
                    {
                        imargin = 20;
                    }

                    iTextSharp.text.Image image = null;

                    try
                    {
                        image = iTextSharp.text.Image.GetInstance(lstImages[0]);
                    }
                    catch
                    {
                        System.Drawing.Image img = ImageHelper.LoadImage(lstImages[0]);

                        image = iTextSharp.text.Image.GetInstance(img, BaseColor.BLACK);
                    }

                    if (pageSize == 0)
                    {
                        doc = new Document(new iTextSharp.text.Rectangle(0, 0, image.Width+2*imargin, image.Height+2*imargin, 0));
                    }
                    else if (pageSize == 1)
                    {
                        doc = new Document(PageSize.A4);
                    }
                    else if (pageSize == 2)
                    {
                        doc = new Document(PageSize.LETTER);
                    }

                    using (PdfWriter writer = PdfWriter.GetInstance(doc, fs))
                    {
                        doc.Open();

                        for (int k = 0; k < lstImages.Count; k++)
                        {                            
                            if (k > 0)
                            {
                                try
                                {
                                    image = iTextSharp.text.Image.GetInstance(lstImages[k]);
                                }
                                catch
                                {
                                    System.Drawing.Image img = ImageHelper.LoadImage(lstImages[k]);

                                    image = iTextSharp.text.Image.GetInstance(img, BaseColor.BLACK);
                                }
                            }

                            if (pageSize == 0 && k>0)
                            {
                                doc.SetPageSize(new iTextSharp.text.Rectangle(0, 0, image.Width+2*imargin, image.Height+2*imargin, 0));
                            }
                            else if (pageSize == 1)
                            {
                                doc.SetPageSize(PageSize.A4);
                            }
                            else if (pageSize == 2)
                            {
                                doc.SetPageSize(PageSize.LETTER);
                            }

                            doc.NewPage();

                            /*
                            else if ((pageSize == 0 && orientation==0) || ((pageSize == 0 && orientation==2) && image.Width<image.Height))
                            {
                                doc.SetPageSize(PageSize.A4);                                    
                            }
                            else if ((pageSize == 0 && orientation==1) || ((pageSize == 0 && orientation==2) && image.Width>=image.Height))
                            {
                                doc.SetPageSize(PageSize.A4.Rotate());
                            }
                            else if ((pageSize == 1 && orientation == 0) || ((pageSize == 1 && orientation == 2) && image.Width < image.Height))
                            {
                                doc.SetPageSize(PageSize.LETTER);
                            }
                            else if ((pageSize == 1 && orientation == 1) || ((pageSize == 1 && orientation == 2) && image.Width >= image.Height))
                            {
                                doc.SetPageSize(PageSize.LETTER.Rotate());
                            }                                
                            */

                            if (pageSize != 0)
                            {

                                int x = 0;
                                int y = 0;

                                int rotation = ((((image.Width >= image.Height) && orientation == 2) || orientation == 1) && pageSize != 0) ? 90 : 0;

                                decimal dw = (decimal)(image.Width);
                                decimal dh = (decimal)(image.Height);

                                // w psh
                                // h  x

                                int nw = 0;
                                int nh = 0;

                                int nwmax = (int)(doc.PageSize.Width - 2 * imargin);
                                int nhmax = (int)(doc.PageSize.Height - 2 * imargin);

                                decimal dnwmax = (decimal)nwmax;
                                decimal dnhmax = (decimal)nhmax;

                                decimal d1 = dw / dh;
                                decimal d2 = dh / dw;

                                if (rotation == 0)
                                {
                                    // dw dh
                                    // nwmax y

                                    nw = nwmax;
                                    //nh = (int)(nwmax * (dh / dw));

                                    nh = (int)(nwmax * d2);

                                    if (nh > nhmax)
                                    {
                                        // dw dh
                                        // x  nhmax

                                        nh = nhmax;
                                        //nw = (int)((dw / dh) * nhmax);

                                        nw = (int)((d1) * nhmax);
                                    }
                                }
                                else if (rotation == 90)
                                {
                                    // dw dh
                                    // nhmax y

                                    nw = (int)nhmax;
                                    //nh = (int)((dh / dw) * nhmax);

                                    nh = (int)((d2) * nhmax);

                                    if (nh > nwmax)
                                    {
                                        // dw dh
                                        // x   nwmax

                                        nh = nwmax;
                                        //nw = (int)((dw / dh) * nwmax);

                                        nw = (int)((d1) * nwmax);
                                    }
                                }

                                writer.AddPageDictEntry(PdfName.ROTATE, new PdfNumber(rotation));

                                //3image.ScaleAbsolute(nw, nh);                                

                                if (rotation == 90)
                                {
                                    image.ScaleToFit(doc.PageSize.Height - 2 * imargin, doc.PageSize.Width - 2 * imargin);

                                    //image.ScaleToFit(nw, nh);

                                    image.RotationDegrees = -270;
                                }
                                else
                                {
                                    image.ScaleToFit(doc.PageSize.Width - 2 * imargin, doc.PageSize.Height - 2 * imargin);

                                    //image.ScaleToFit(nw, nh);
                                }

                                //3image.ScaleToFit(nw, nh);


                                // 0 middle center
                                // 1 top center
                                // 2 bottom center
                                // 3 middle left
                                // 4 top left
                                // 5 bottom left
                                // 6 middle right
                                // 7 top right
                                // 8 bottom right

                                //if (image.ScaledWidth >= image.ScaledHeight && alignment == 0) // center landscape
                                if (rotation == 90 && alignment == 0) // middle center landscape
                                {
                                    //x = imargin+(int)((doc.PageSize.Height-2*imargin) / 2 - image.ScaledWidth / 2);
                                    //y =imargin+ (int)((doc.PageSize.Width-2*imargin) / 2 - image.ScaledHeight / 2);
                                    y = imargin + (int)((doc.PageSize.Height - 2 * imargin) / 2 - image.ScaledHeight / 2);
                                    x = imargin + (int)((doc.PageSize.Width - 2 * imargin) / 2 - image.ScaledWidth / 2);
                                }
                                //else if (image.ScaledWidth < image.ScaledHeight && alignment == 0) // center normal
                                else if (rotation == 0 && alignment == 0) // middle center normal
                                {
                                    //y =imargin+ (int)((doc.PageSize.Height-2*imargin) / 2 - image.ScaledHeight / 2);
                                    //x =imargin+ (int)((doc.PageSize.Width-2*imargin) / 2 - image.ScaledWidth / 2);

                                    //3y = (int)((doc.PageSize.Height) / 2 - image.ScaledHeight / 2);
                                    //3x = (int)((doc.PageSize.Width) / 2 - image.ScaledWidth / 2);

                                    y = (int)((doc.PageSize.Height) / 2 - image.ScaledHeight / 2);
                                    x = (int)((doc.PageSize.Width) / 2 - image.ScaledWidth / 2);
                                }
                                //if (image.ScaledWidth >= image.ScaledHeight && alignment == 0) // center landscape
                                else if (rotation == 90 && alignment == 6) // top center landscape - middle right
                                {
                                    y = (int)(doc.PageSize.Height - imargin - image.ScaledHeight);
                                    x = (int)((doc.PageSize.Width) / 2 - image.ScaledWidth / 2);
                                }
                                //else if (image.ScaledWidth < image.ScaledHeight && alignment == 0) // center normal
                                else if (rotation == 0 && alignment == 1) // top center normal
                                {
                                    y = (int)(doc.PageSize.Height - imargin - image.ScaledHeight);
                                    x = (int)((doc.PageSize.Width) / 2 - image.ScaledWidth / 2);
                                }
                                //if (image.ScaledWidth >= image.ScaledHeight && alignment == 0) // center landscape
                                else if (rotation == 90 && alignment == 3) // bottom center landscape - middle left
                                {
                                    y = (int)(imargin);
                                    x = (int)((doc.PageSize.Width) / 2 - image.ScaledWidth / 2);
                                }
                                //else if (image.ScaledWidth < image.ScaledHeight && alignment == 0) // center normal
                                else if (rotation == 0 && alignment == 2) // bottom center normal
                                {
                                    y = imargin;
                                    x = (int)((doc.PageSize.Width) / 2 - image.ScaledWidth / 2);
                                }
                                //if (image.ScaledWidth >= image.ScaledHeight && alignment == 0) // center landscape
                                else if (rotation == 90 && alignment == 1) // middle left landscape - top center
                                {
                                    y = (int)((doc.PageSize.Height) / 2 - image.ScaledHeight / 2);
                                    x = imargin;
                                }
                                //else if (image.ScaledWidth < image.ScaledHeight && alignment == 0) // center normal
                                else if (rotation == 0 && alignment == 3) // middle left normal
                                {
                                    y = (int)((doc.PageSize.Height) / 2 - image.ScaledHeight / 2);
                                    x = imargin;
                                }
                                //else if (image.ScaledWidth >= image.ScaledHeight && alignment == 1) // top
                                else if (rotation == 90 && alignment == 7) // top left - top right
                                {
                                    y = (int)(doc.PageSize.Height - imargin - image.ScaledHeight);
                                    x = imargin;
                                }
                                //else if (image.ScaledWidth < image.ScaledHeight && alignment == 2)
                                else if (rotation == 0 && alignment == 4) // top left
                                {
                                    x = (int)(imargin);
                                    y = (int)(doc.PageSize.Height - image.ScaledHeight - imargin);
                                }
                                //else if (image.ScaledWidth >= image.ScaledHeight && alignment == 1) // top
                                else if (rotation == 90 && alignment == 4) // bottom left - top left
                                {
                                    y = imargin;
                                    x = imargin;
                                }
                                //else if (image.ScaledWidth < image.ScaledHeight && alignment == 2)
                                else if (rotation == 0 && alignment == 5) // bottom left
                                {
                                    x = (int)(imargin);
                                    y = imargin;
                                }
                                //if (image.ScaledWidth >= image.ScaledHeight && alignment == 0) // center landscape
                                else if (rotation == 90 && alignment == 2) // middle right landscape - bottom center
                                {
                                    y = (int)((doc.PageSize.Height) / 2 - image.ScaledHeight / 2);
                                    x = (int)(doc.PageSize.Width - imargin - image.ScaledWidth);
                                }
                                //else if (image.ScaledWidth < image.ScaledHeight && alignment == 0) // center normal
                                else if (rotation == 0 && alignment == 6) // middle right normal
                                {
                                    y = (int)((doc.PageSize.Height) / 2 - image.ScaledHeight / 2);
                                    x = (int)(doc.PageSize.Width - imargin - image.ScaledWidth);
                                }
                                //else if (image.ScaledWidth < image.ScaledHeight && alignment == 1)
                                else if (rotation == 0 && alignment == 7) // top right
                                {
                                    x = (int)(doc.PageSize.Width - imargin - image.ScaledWidth);
                                    y = (int)(doc.PageSize.Height - image.ScaledHeight - imargin);
                                }
                                //else if (image.ScaledWidth >= image.ScaledHeight && alignment == 2) // bottom
                                else if (rotation == 90 && alignment == 8) // top right - bottom right
                                {
                                    y = (int)(doc.PageSize.Height - image.ScaledHeight - imargin);
                                    x = (int)(doc.PageSize.Width - image.ScaledWidth - imargin);
                                }
                                //else if (image.ScaledWidth < image.ScaledHeight && alignment == 1)
                                else if (rotation == 0 && alignment == 8) // bottom right
                                {
                                    x = (int)(doc.PageSize.Width - imargin - image.ScaledWidth);
                                    y = imargin;
                                }
                                //else if (image.ScaledWidth >= image.ScaledHeight && alignment == 2) // bottom
                                else if (rotation == 90 && alignment == 5) // bottom right - bottom left
                                {
                                    y = (int)(imargin);
                                    x = (int)(doc.PageSize.Width - image.ScaledWidth - imargin);
                                }


                                image.SetAbsolutePosition(x, y);

                                //image.SetAbsolutePosition(0, 0);

                            }
                            else
                            {
                                image.SetAbsolutePosition(imargin, imargin);
                            }

                            //writer.DirectContent.AddImage(image, false);

                            writer.DirectContentUnder.AddImage(image);

                            //writer.DirectContent.AddImage(image);

                            //3doc.NewPage();
                        }
                        doc.Close();
                    }
                    //}
                }

                return "";
            }

            catch (Exception ex)
            {
                return "Error could not convert Images to PDF " + " " + ex.Message;
            }
        }
    }
}
