﻿using System;
using System.Collections.Generic;
using System.Text;
using iTextSharp;
using iTextSharp.text.pdf;
using iTextSharp.text;
using System.IO;

namespace PDFUtilitiesNew
{
    class PDFCombiner
    {
        public static string CombinePDF(string password,string outputFile,List<string> inputFiles)
        {
            string err = "";

            try
            {
                Document document = new Document();
                PdfCopy copy = new PdfSmartCopy(document, new FileStream(outputFile, FileMode.OpenOrCreate));
                document.Open();

                for (int k = 0; k < inputFiles.Count; k++)
                {
                    PdfReader reader;
                    // loop over readers
                    // add the PDF to PdfCopy

                    //3reader = new PdfReader(dt.Rows[k]["fullfilepath"].ToString());

                    if (string.IsNullOrEmpty(password))
                    {
                        reader = new PdfReader(inputFiles[k]);
                    }
                    else
                    {
                        reader = new PdfReader(inputFiles[k], Encoding.ASCII.GetBytes(password));
                    }

                    copy.AddDocument(reader);
                    reader.Close();
                    reader.Dispose();
                    reader = null;

                    System.Threading.Thread.Sleep(500);
                }
                // end loop
                document.Close();

                //throw new Exception("test");
            }
            catch (Exception ex)
            {
                err += "Error could not Combine PDF Documents ! " + ex.Message;
            }

            return err;
        }
    }
}
