﻿using System;
using System.Collections.Generic;
using System.Text;
using iTextSharp.text.pdf;
using iTextSharp.text.pdf.parser;
using System.Data;
using System.IO;

namespace PDFUtilitiesNew
{
    class PDFToHTMLConverter
    {
        public static string ConvertPDFToHTML(string filepath, string password, string outputFile)
        {
            try
            {
                PdfReader reader = null;

                if (String.IsNullOrEmpty(password))
                {
                    reader = new PdfReader(filepath);
                }
                else
                {
                    reader = new PdfReader(filepath, Encoding.Default.GetBytes(password));
                }

                StringBuilder sb = new StringBuilder();

                
                    //sw.WriteLine("=============================================================");
                    //sw.WriteLine(System.IO.Path.GetFileName(filepath));
                    //sw.WriteLine("=============================================================");


                    for (int i = 1; i <= reader.NumberOfPages; i++)
                    {
                        string str = iTextSharp.text.pdf.parser.PdfTextExtractor.GetTextFromPage(reader, i);

                        if (str != string.Empty)
                        {
                            sb.AppendLine(str);
                        }
                    }

                    StringBuilder sbhtml = new StringBuilder();
                    sbhtml.AppendLine("<html>");
                    sbhtml.AppendLine("<body>");


                using (StringReader sr=new StringReader(sb.ToString()))
                {
                    string line = null;

                    while ((line = sr.ReadLine()) != null)
                    {
                        sbhtml.AppendLine("<p>" + line + "</p>");
                    }
                }

                sbhtml.AppendLine("</body>");
                sbhtml.AppendLine("</html>");

                System.IO.File.WriteAllText(outputFile, sbhtml.ToString());

                return "";
            }
            catch (Exception ex)
            {
                return "Error-Count not Convert PDF to HTML " + System.IO.Path.GetFileName(filepath) + " " + ex.Message;
            }
        }
    }
}
