﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PdfToImage;

namespace PDFUtilitiesNew
{
    class PDFToJPGConverter
    {
        public static string ConvertPDFToJPG(string inputFilepath, string outputDir, int selectedFormat,int iwidth, int iheight, int idpi,int iquality, bool oneImage,bool fitPage,string pageRanges)
        {
            try
            {
                List<string> cmbOutputFormat = new List<string>();
                List<string> cmbOutputFormatCodes = new List<string>();
                List<string> cmbOutputFormatExtension = new List<string>();

                cmbOutputFormat.Add("PNG");
                cmbOutputFormatCodes.Add("png16m");
                cmbOutputFormatExtension.Add("png");

                cmbOutputFormat.Add("JPEG");
                cmbOutputFormatCodes.Add("jpeg");
                cmbOutputFormatExtension.Add("jpg");
                cmbOutputFormat.Add("BMP");
                cmbOutputFormatExtension.Add("bmp");
                cmbOutputFormatCodes.Add("bmp16m");
                cmbOutputFormat.Add("PCX");
                cmbOutputFormatExtension.Add("pcx");
                cmbOutputFormatCodes.Add("pcx24b");
                cmbOutputFormat.Add("PSD");
                cmbOutputFormatExtension.Add("psd");
                cmbOutputFormatCodes.Add("psdrgb");
                cmbOutputFormat.Add("TIFF G4 FAX Encoding");
                cmbOutputFormatCodes.Add("tiffg4");
                cmbOutputFormatExtension.Add("tif");
                cmbOutputFormat.Add("TIFF LZW Compression");
                cmbOutputFormatCodes.Add("tifflzw");
                cmbOutputFormatExtension.Add("tif");
                cmbOutputFormat.Add("TIFF 24 Bit uncompressed");
                cmbOutputFormatCodes.Add("tiff24nc");
                cmbOutputFormatExtension.Add("tif");
                cmbOutputFormat.Add("JPEG Grayscale");
                cmbOutputFormatCodes.Add("jpeggray");
                cmbOutputFormatExtension.Add("jpg");
                cmbOutputFormat.Add("PNG Grayscale");
                cmbOutputFormatCodes.Add("pnggray");
                cmbOutputFormatExtension.Add("png");
                cmbOutputFormat.Add("PNG 256 Colors (8-bit)");
                cmbOutputFormatCodes.Add("png256");
                cmbOutputFormatExtension.Add("png");
                cmbOutputFormat.Add("PNG 16 Colors (4-bit)");
                cmbOutputFormatCodes.Add("png16");
                cmbOutputFormatExtension.Add("png");
                cmbOutputFormat.Add("PNG Monochrome");
                cmbOutputFormatCodes.Add("pngmono");
                cmbOutputFormatExtension.Add("png");

                string outformat=cmbOutputFormatCodes[selectedFormat];

                string outext = cmbOutputFormatExtension[selectedFormat];

                string[] ranges = null;

                if (pageRanges != string.Empty)
                {
                    ranges = pageRanges.Split(new string[] { "," }, StringSplitOptions.RemoveEmptyEntries);
                }

                int rangesLen=ranges==null? 1 : ranges.Length;

                for (int k = 0; k < rangesLen; k++)
                {
                    PDFConvert con = new PDFConvert();

                    if (oneImage)
                    {
                        con.OutputToMultipleFile = false;
                    }
                    else
                    {
                        con.OutputToMultipleFile = true;                        
                    }

                    con.FitPage = fitPage;

                    con.OutputFormat = outformat;

                    con.ResolutionX = idpi;
                    con.ResolutionY = idpi;

                    int ifrom = 0;
                    int ito = 0;

                    if (ranges != null)
                    {
                        if (ranges[k].IndexOf("-") >= 0)
                        {
                            string[] ranges2 = ranges[k].Split(new string[] { "-" }, StringSplitOptions.RemoveEmptyEntries);

                            ifrom = int.Parse(ranges2[0]);
                            ito = int.Parse(ranges2[1]);
                        }
                        else
                        {
                            ifrom = int.Parse(ranges[k]);
                            ito = ifrom;
                        }
                    }

                    if (!(ifrom == 0 && ito == 0))
                    {
                        con.FirstPageToConvert = ifrom;
                        con.LastPageToConvert = ito;
                    }

                    con.JPEGQuality = iquality;

                    if (!(iwidth == 0 && iheight == 0))
                    {
                        con.Width = iwidth;
                        con.Height = iheight;
                    }

                    //3string CurrentProcessingFilepathWithoutExtension = System.IO.Path.Combine(outputDir, System.IO.Path.GetFileName(inputFilepath)+ "." + k.ToString());

                    string CurrentProcessingFilepathWithoutExtension = System.IO.Path.Combine(outputDir, System.IO.Path.GetFileName(inputFilepath) + ".From Page " + (ifrom==0?"1":ifrom.ToString()));
                    string CurrentProcessingFileExtension = ".." + outext;

                    string outfile = CurrentProcessingFilepathWithoutExtension + CurrentProcessingFileExtension;

                    con.Convert(inputFilepath, outfile);                                                        
                }                

            return "";
            }

            catch (Exception ex)
            {
                return "Error could not convert PDF to JPG " + " " + ex.Message;
            }
        }
    }
}
