﻿using System;
using System.Collections.Generic;
using System.Text;
using iTextSharp.text.pdf;
using iTextSharp.text.pdf.parser;
using System.Data;
using System.IO;

namespace PDFUtilitiesNew
{
    class PDFToRTFConverter
    {
        public static string ConvertPDFToRTF(string filepath, string password, string outputFile)
        {
            try
            {
                PdfReader reader = null;

                if (String.IsNullOrEmpty(password))
                {
                    reader = new PdfReader(filepath);
                }
                else
                {
                    reader = new PdfReader(filepath, Encoding.Default.GetBytes(password));
                }

                StringBuilder sb = new StringBuilder();                

                for (int i = 1; i <= reader.NumberOfPages; i++)
                {
                    string str = iTextSharp.text.pdf.parser.PdfTextExtractor.GetTextFromPage(reader, i);

                    if (str != string.Empty)
                    {
                        sb.AppendLine(str);
                    }
                }

                System.Windows.Forms.RichTextBox rtb = new System.Windows.Forms.RichTextBox();
                rtb.Text = sb.ToString();
                //rtb.SaveFile(outputFile, System.Windows.Forms.RichTextBoxStreamType.RichText);

                System.IO.File.WriteAllText(outputFile, rtb.Rtf);

                return "";
            }
            catch (Exception ex)
            {
                return "Error-Count not Convert PDF to HTML " + System.IO.Path.GetFileName(filepath) + " " + ex.Message;
            }
        }
    }
}
