﻿using System;
using System.Collections.Generic;
using System.Text;
using iTextSharp.text.pdf;
using iTextSharp.text.pdf.parser;
using System.Data;
using System.IO;

namespace PDFUtilitiesNew
{
    class PDFToTextConverter
    {
        public static string ConvertPDFToText(string filepath, string password,string outputFile)
        {            
            try
            {
                PdfReader reader = null;

                if (String.IsNullOrEmpty(password))
                {
                    reader = new PdfReader(filepath);
                }
                else
                {
                    reader = new PdfReader(filepath, Encoding.Default.GetBytes(password));
                }

                using (StreamWriter sw = new StreamWriter(outputFile, true))
                {
                    sw.WriteLine("=============================================================");
                    sw.WriteLine(System.IO.Path.GetFileName(filepath));
                    sw.WriteLine("=============================================================");


                    for (int i = 1; i <= reader.NumberOfPages; i++)
                    {
                        string str = iTextSharp.text.pdf.parser.PdfTextExtractor.GetTextFromPage(reader, i);

                        if (str != string.Empty)
                        {
                            sw.WriteLine(str);
                        }
                    }
                }

                return "";
            }
            catch (Exception ex)
            {
                return "Error-Count not Convert PDF to Text " + System.IO.Path.GetFileName(filepath) + " " + ex.Message;
            }
        }
    }
}
