﻿using System;
using System.Collections.Generic;
using System.Text;
using iTextSharp.text.pdf;
using iTextSharp.text.pdf.parser;
using iTextSharp.text;

namespace PDFUtilitiesNew
{
    class Program
    {
        static void Main(string[] args)
        {
            args = RemoveQuotes(args);

            string[] asa=new string[] { "/test"};

            //args = asa;

            if (args[0] == "/combine")
            {
                string password = args[1];

                if (password == string.Empty)
                {
                    password = null;
                }

                string inputDir = args[2];

                string outputFile = args[3];

                string inputFilesList = args[4];

                string[] filez = inputFilesList.Split(new string[] { "|||" }, StringSplitOptions.RemoveEmptyEntries);
                
                //List<string> inputFiles = new List<string>(filez);                

                List<string> inputFiles = new List<string>();

                for (int k = 0; k < filez.Length; k++)
                {
                    inputFiles.Add(System.IO.Path.Combine(inputDir,filez[k]));
                }

                string err = PDFCombiner.CombinePDF(password, outputFile, inputFiles);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/countpages")
            {
                string password = args[1];

                if (password == string.Empty)
                {
                    password = null;
                }

                string inputFile = args[2];

                string err = PDFPageCounter.CountPDFPages(password, inputFile);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/pdftotxt")
            {
                string password = args[1];

                if (password == string.Empty)
                {
                    password = null;
                }

                string inputFile = args[2];

                string outputFile = args[3];

                string err = PDFToTextConverter.ConvertPDFToText(inputFile, password,outputFile);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/pdftohtml")
            {
                string password = args[1];

                if (password == string.Empty)
                {
                    password = null;
                }

                string inputFile = args[2];

                string outputFile = args[3];

                string err = PDFToHTMLConverter.ConvertPDFToHTML(inputFile, password, outputFile);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/pdftortf")
            {
                string password = args[1];

                if (password == string.Empty)
                {
                    password = null;
                }

                string inputFile = args[2];

                string outputFile = args[3];

                string err = PDFToRTFConverter.ConvertPDFToRTF(inputFile, password, outputFile);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/htmltopdf")
            {                
                string inputFile = args[1];

                string outputFile = args[2];

                string err = HTMLToPDFConverter.ConvertHTMLToPDF(inputFile, outputFile);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/texttopdf")
            {
                string inputFile = args[1];

                string outputFile = args[2];

                string err = TextToPDFConverter.ConvertTextToPDF(inputFile, outputFile);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/deletepages")
            {
                string inputFile = args[1];

                string outputFile = args[2];

                string password = args[3];

                if (password == string.Empty)
                {
                    password = null;
                }

                bool emptyPages = args[4] == bool.TrueString;

                string pageRanges = args[5];

                bool pagesEvery = args[6] == bool.TrueString;

                int pagesEveryValue = int.Parse(args[7]);

                bool oddPages = args[8] == bool.TrueString;

                bool evenPages = args[9] == bool.TrueString;

                bool containingText = args[10] == bool.TrueString;

                string textToContain = args[11];

                string err = PDFPageDeleter.DeletePDFPages(password,inputFile, outputFile, emptyPages, pageRanges, pagesEvery, pagesEveryValue,
                    oddPages, evenPages, containingText, textToContain);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/split")
            {
                string inputFile = args[1];

                string outputDir = args[2];

                string password = args[3];

                if (password == string.Empty)
                {
                    password = null;
                }

                bool emptyPages = args[4] == bool.TrueString;

                int emptyPagesValue = int.Parse(args[5]);

                string pageRanges = args[6];

                bool pagesEvery = args[7] == bool.TrueString;

                int pagesEveryValue = int.Parse(args[8]);

                bool oddPages = args[9] == bool.TrueString;

                bool evenPages = args[10] == bool.TrueString;

                bool containingText = args[11] == bool.TrueString;

                string textToContain = args[12];

                bool splitBookmarks = args[13] == bool.TrueString;

                int bookmarksLevel = int.Parse(args[14]);

                string err = PDFSplitter.SplitPDFPages(password, inputFile, outputDir, emptyPages, emptyPagesValue, pageRanges, pagesEvery, pagesEveryValue,
                    oddPages, evenPages, containingText, textToContain,splitBookmarks,bookmarksLevel);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/extract")
            {
                string inputFile = args[1];

                string outputFile = args[2];

                string password = args[3];

                if (password == string.Empty)
                {
                    password = null;
                }                

                string pageRanges = args[4];

                bool pagesEvery = args[5] == bool.TrueString;

                int pagesEveryValue = int.Parse(args[6]);

                bool oddPages = args[7] == bool.TrueString;

                bool evenPages = args[8] == bool.TrueString;

                bool containingText = args[9] == bool.TrueString;

                string textToContain = args[10];                

                string err = PDFExtractor.ExtractPDFPages(password, inputFile, outputFile, pageRanges, pagesEvery, pagesEveryValue,
                    oddPages, evenPages, containingText, textToContain);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/watermark")
            {
                string inputFile = args[1];

                string outputFile = args[2];

                string password = args[3];

                if (password == string.Empty)
                {
                    password = null;
                }

                int r = int.Parse(args[4]);
                int g = int.Parse(args[5]);
                int b = int.Parse(args[6]);

                float fontSize = float.Parse(args[7]);

                int angle = int.Parse(args[8]);

                string position = args[9];

                string watermarkText = args[10];

                string imageFilepath = args[11];

                string err = PDFWatermarker.WatermarkPDF(inputFile, outputFile, password,
                    r, g, b, fontSize, angle, position, watermarkText, imageFilepath);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/rotate")
            {
                string inputFile = args[1];

                string outputFile = args[2];

                string password = args[3];

                if (password == string.Empty)
                {
                    password = null;
                }                

                string pageRanges = args[4];

                bool pagesEvery = args[5] == bool.TrueString;

                int pagesEveryValue = int.Parse(args[6]);

                bool oddPages = args[7] == bool.TrueString;

                bool evenPages = args[8] == bool.TrueString;

                bool containingText = args[9] == bool.TrueString;

                string textToContain = args[10];

                int angle = int.Parse(args[11]);

                string err = PDFRotator.RotatePDFPages(password, inputFile, outputFile, pageRanges, pagesEvery, pagesEveryValue,
                    oddPages, evenPages, containingText, textToContain,angle);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/pagenumbers")
            {
                string inputFile = args[1];

                string outputFile = args[2];

                string password = args[3];

                if (password == string.Empty)
                {
                    password = null;
                }                                

                string position = args[4];

                int numberFormat = int.Parse(args[5]);

                string customFormat = args[6];                

                int fromPage=int.Parse(args[7]);

                int toPage=int.Parse(args[8]);

                string err = PageNumbersCreator.SetPageNumbers(inputFile, outputFile, password, fromPage, toPage, numberFormat, customFormat, position);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/headerfooter")
            {                
                string inputFile = args[1];

                string outputFile = args[2];

                string password = args[3];

                if (password == string.Empty)
                {
                    password = null;
                }

                string headerText = args[4];

                int headerAlignment = int.Parse(args[5]);

                string footerText = args[6];

                int footerAlignment = int.Parse(args[7]);

                string err = PDFHeaderFooterCreator.SetPDFHeaderFooter(inputFile, outputFile, password,
                    headerText, headerAlignment, footerText, footerAlignment);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/metadata")
            {
                string inputFile = args[1];

                string outputFile = args[2];

                string password = args[3];

                if (password == string.Empty)
                {
                    password = null;
                }

                bool clearAllMetadata = args[4] == bool.TrueString;

                bool chkTitleNewValue = args[5] == bool.TrueString;

                string titleNewValue = args[6];                

                bool chkAuthorNewValue = args[7] == bool.TrueString;

                string AuthorNewValue = args[8];                

                bool chkSubjectNewValue = args[9] == bool.TrueString;

                string SubjectNewValue = args[10];                

                bool chkKeywordsNewValue = args[11] == bool.TrueString;

                string KeywordsNewValue = args[12];                

                bool chkCreatorNewValue = args[13] == bool.TrueString;

                string CreatorNewValue = args[14];                

                bool chkCreationDateNewValue = args[15] == bool.TrueString;

                string CreationDateNewValue = args[16];                

                bool chkModDateNewValue = args[17] == bool.TrueString;

                string ModDateNewValue = args[18];                

                bool wildcards = args[19] == bool.TrueString;

                bool regexp = args[20] == bool.TrueString;

                bool findreplace = args[21] == bool.TrueString;

                string find = args[22];

                string replace = args[23];

                List<string> customName = new List<string>();

                List<string> customValue = new List<string>();

                for (int k = 24; k < args.Length; k += 2)
                {
                    customName.Add(args[k]);
                    customValue.Add(args[k + 1]);
                }

                string err = PDFMetadataEditor.EditPDFMetadata(
                     inputFile, outputFile, password, clearAllMetadata,
             chkTitleNewValue, titleNewValue, 
             chkAuthorNewValue, AuthorNewValue, 
             chkSubjectNewValue, SubjectNewValue, 
             chkKeywordsNewValue, KeywordsNewValue, 
             chkCreatorNewValue, CreatorNewValue, 
             chkCreationDateNewValue, CreationDateNewValue, 
             chkModDateNewValue, ModDateNewValue, wildcards,regexp,
             findreplace, find, replace,
            customName, customValue);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/jpgtopdf" || args[0] == "/pngtopdf" || args[0] == "/tifftopdf" || args[0] == "/bmptopdf" || args[0] == "/imagetopdf")
            {
                string inputDir = args[1];

                string outputFile = args[2];

                int pageSize = int.Parse(args[3]);

                int orientation = int.Parse(args[4]);

                int margin = int.Parse(args[5]);

                int alignment = int.Parse(args[6]);

                List<string> lstImages = new List<string>();

                for (int m = 7; m < args.Length; m++)
                {
                    lstImages.Add(System.IO.Path.Combine(inputDir,args[m]));
                }

                string err = ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/pdftojpg")
            {
                string inputFilepath=args[1];

                string outputDir=args[2];

                int selectedFormat=int.Parse(args[3]);

                int iwidth=int.Parse(args[4]);

                int iheight=int.Parse(args[5]);

                int idpi=int.Parse(args[6]);

                int iquality=int.Parse(args[7]);

                bool oneImage=args[8]==bool.TrueString;
                    
                bool fitPage=args[9]==bool.TrueString;

                string pageRanges = args[10];

                string err = PDFToJPGConverter.ConvertPDFToJPG(
                    inputFilepath, outputDir, selectedFormat, iwidth, iheight, idpi, iquality, oneImage, fitPage, pageRanges);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/test")
            {
                string inputFilepath = @"C:\Users\alex\Documents\doc with empty pages.pdf";

                string outputDir = @"c:\1\pdftojpg-result";

                if (!System.IO.Directory.Exists(outputDir))
                {
                    System.IO.Directory.CreateDirectory(outputDir);
                }

                int selectedFormat = 0;

                int iwidth = 0;

                int iheight = 0;

                int idpi = 300;

                int iquality = 100;

                bool oneImage = false;

                bool fitPage = false;

                string pageRanges = "";

                string err = PDFToJPGConverter.ConvertPDFToJPG(
                    inputFilepath, outputDir, selectedFormat, iwidth, iheight, idpi, iquality, oneImage, fitPage, pageRanges);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }
            }
            else if (args[0] == "/test3")
            {
                string err = "";

                for (int m = 0; m <= 2; m++)
                {
                    string outputFile = @"c:\1\imageToPDFResult.pdf";

                    int pageSize = 0;
                    int orientation = m;
                    int margin = 1;
                    int alignment = 0;

                    List<string> lstImages = new List<string>()
                {
                    @"C:\dat2\Jennie Garth.jpg",
                    @"C:\code\Graphics Utilities\Test Images\alex.jp2",
                    @"C:\dat2\patricia-arket-xrises-sfaires-2020.jpg",
                    @"C:\dat2\eva-padlock-b640_0.png",
                    @"C:\dat2\xanthia.png",
                    @"C:\dat2\panagiotarounew_0.jpg",
                    @"C:\dat2\111228.jpg",
                    @"C:\dat2\korakaki-brazil-tmesa.jpg",
                    @"C:\dat2\valentina-vitale-c640.jpg"
                };

                    err = ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);

                    outputFile = @"c:\1\imageToPDFResult2.pdf";

                    alignment = 1;

                    ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);

                    outputFile = @"c:\1\imageToPDFResult3.pdf";

                    alignment = 2;

                    ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);

                    //

                    outputFile = @"c:\1\imageToPDFResult4.pdf";

                    alignment = 3;

                    ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);

                    outputFile = @"c:\1\imageToPDFResult5.pdf";

                    alignment = 4;

                    ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);

                    outputFile = @"c:\1\imageToPDFResult6.pdf";

                    alignment = 5;

                    ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);

                    //

                    outputFile = @"c:\1\imageToPDFResult7.pdf";

                    alignment = 6;

                    ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);

                    outputFile = @"c:\1\imageToPDFResult8.pdf";

                    alignment = 7;

                    ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);

                    outputFile = @"c:\1\imageToPDFResult9.pdf";

                    alignment = 8;

                    ImageToPDFConverter.ConvertImageToPDF(outputFile, pageSize, orientation, margin, alignment, lstImages);
                }

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }

            }
            else if (args[0] == "/test3")
            {
                string inputFile = @"C:\Users\alex\Documents\doc with empty pages.pdf";

                string outputFile1 = @"C:\Users\alex\Documents\doc with empty pages-watermarked1.pdf";
                string outputFile2 = @"C:\Users\alex\Documents\doc with empty pages-watermarked2.pdf";
                string outputFile3 = @"C:\Users\alex\Documents\doc with empty pages-watermarked3.pdf";
                string outputFile4 = @"C:\Users\alex\Documents\doc with empty pages-watermarked4.pdf";
                string outputFile5 = @"C:\Users\alex\Documents\doc with empty pages-watermarked5.pdf";
                string outputFile6 = @"C:\Users\alex\Documents\doc with empty pages-watermarked6.pdf";
                string outputFile7 = @"C:\Users\alex\Documents\doc with empty pages-watermarked7.pdf";
                string outputFile8 = @"C:\Users\alex\Documents\doc with empty pages-watermarked8.pdf";
                string outputFile9 = @"C:\Users\alex\Documents\doc with empty pages-watermarked9.pdf";

                /*
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile1, 0, 0, 0, 40, 45, "Top Left", "ALEX");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile2, 0, 0, 0, 40, 45, "Top Center", "ALEX");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile3, 0, 0, 0, 40, 45, "Top Right", "ALEX");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile4, 0, 0, 0, 40, 45, "Middle Left", "ALEX");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile5, 0, 0, 0, 40, 45, "Middle Center", "ALEX");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile6, 0, 0, 0, 40, 45, "Middle Right", "ALEX");                
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile7, 0, 0, 0, 40, 45, "Bottom Left", "ALEX");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile8, 0, 0, 0, 40, 45, "Bottom Center", "ALEX");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile9, 0, 0, 0, 40, 45, "Bottom Right", "ALEX");
                */

                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile1, 0, 0, 0, 40, 45, "Top Left", "ALEX", @"C:\codegraphics\Icons - IconExperience - All Collections 1.6_(Retail)\Collection.1.Application.Basics\48x48\shadow\documents_preferences.png");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile2, 0, 0, 0, 40, 45, "Top Center", "ALEX", @"C:\codegraphics\Icons - IconExperience - All Collections 1.6_(Retail)\Collection.1.Application.Basics\48x48\shadow\documents_preferences.png");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile3, 0, 0, 0, 40, 45, "Top Right", "ALEX", @"C:\codegraphics\Icons - IconExperience - All Collections 1.6_(Retail)\Collection.1.Application.Basics\48x48\shadow\documents_preferences.png");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile4, 0, 0, 0, 40, 45, "Middle Left", "ALEX", @"C:\codegraphics\Icons - IconExperience - All Collections 1.6_(Retail)\Collection.1.Application.Basics\48x48\shadow\documents_preferences.png");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile5, 0, 0, 0, 40, 45, "Middle Center", "ALEX", @"C:\codegraphics\Icons - IconExperience - All Collections 1.6_(Retail)\Collection.1.Application.Basics\48x48\shadow\documents_preferences.png");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile6, 0, 0, 0, 40, 45, "Middle Right", "ALEX", @"C:\codegraphics\Icons - IconExperience - All Collections 1.6_(Retail)\Collection.1.Application.Basics\48x48\shadow\documents_preferences.png");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile7, 0, 0, 0, 40, 45, "Bottom Left", "ALEX", @"C:\codegraphics\Icons - IconExperience - All Collections 1.6_(Retail)\Collection.1.Application.Basics\48x48\shadow\documents_preferences.png");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile8, 0, 0, 0, 40, 45, "Bottom Center", "ALEX", @"C:\codegraphics\Icons - IconExperience - All Collections 1.6_(Retail)\Collection.1.Application.Basics\48x48\shadow\documents_preferences.png");
                PDFWatermarker.WatermarkPDF(inputFile, "", outputFile9, 0, 0, 0, 40, 45, "Bottom Right", "ALEX", @"C:\codegraphics\Icons - IconExperience - All Collections 1.6_(Retail)\Collection.1.Application.Basics\48x48\shadow\documents_preferences.png");
            }
            else if (args[0] == "/test2")
            {
                string inputFile = @"F:\ebooks\jquery\[Bintu_Harwani]_jQuery__Recipes_A_Problem-Solutio(BookFi.org).pdf";
                string err = PDFSplitter.SplitPDFPages("", inputFile, @"c:\1\", false, 0, "", false, 1,
                    false, false, false, "", true, 1);

                if (err != string.Empty)
                {
                    Console.WriteLine(err);
                }

                return;

                //string inputFile=args[1];


                PdfReader reader = null;

                reader = new PdfReader(inputFile);

                for (int k = 1; k <= reader.NumberOfPages; k++)
                {
                    PdfDictionary pageDict = reader.GetPageN(k);
                    // We need to examine the resource dictionary for /Font or
                    // /XObject keys.  If either are present, they're almost
                    // certainly actually used on the page -> not blank.
                    PdfDictionary resDict = (PdfDictionary)pageDict.Get(PdfName.RESOURCES);
                    if (resDict != null)
                    {
                        string txt = iTextSharp.text.pdf.parser.PdfTextExtractor.GetTextFromPage(reader, k);

                        if (txt != null)
                        {
                            txt = txt.Trim();
                        }

                        bool noFontsOrImages = string.IsNullOrEmpty(txt) && resDict.Get(PdfName.XOBJECT) == null;
                        /*
                        bool noFontsOrImages = resDict.Get(PdfName.FONT) == null &&
                          resDict.Get(PdfName.XOBJECT) == null;
                        */
                        bool isempty = noFontsOrImages;
                        /*
                        bool isempty = reader.GetPageContent(k).Length == 0;
                        */
                        if (isempty)
                        {
                            Console.WriteLine("Empty " + k.ToString());
                        }
                    }
                }
            }
        }

        public static string[] RemoveQuotes(string[] args)
        {
            for (int k = 0; k < args.Length; k++)
            {
                if (args[k].StartsWith("\"") && args[k].EndsWith("\""))
                {
                    if (args[k].Length > 2)
                    {
                        args[k] = args[k].Substring(1, args.Length - 2);
                    }
                    else
                    {
                        args[k] = "";
                    }
                }
                else if (args[k].StartsWith("'") && args[k].EndsWith("'"))
                {
                    if (args[k].Length > 2)
                    {
                        args[k] = args[k].Substring(1, args.Length - 2);
                    }
                    else
                    {
                        args[k] = "";
                    }
                }
            }

            return args;
        }
    }
}
