﻿using System;
using System.Collections.Generic;
using System.Text;
using iTextSharp.text;
using iTextSharp.text.html.simpleparser;
using iTextSharp.text.pdf;
using System.IO;

namespace PDFUtilitiesNew
{
    class TextToPDFConverter
    {
        public static string ConvertTextToPDF(string filepath, string outputFile)
        {
            try
            {
                using (StringReader sr = new StringReader(System.IO.File.ReadAllText(filepath)))
                {
                    Document doc = new Document(PageSize.A4, 10f, 10f, 10f, 0f);
                    
                    PdfWriter.GetInstance(doc, new FileStream(outputFile, FileMode.Create));

                    //Open the Document

                    doc.Open();

                    //Add the content of Text File to PDF File

                    doc.Add(new Paragraph(sr.ReadToEnd()));

                    //Close the Document

                    doc.Close();
                }

                return "";
            }
            catch (Exception ex)
            {
                return "Error-Count not Convert Text to PDF " + System.IO.Path.GetFileName(filepath) + " " + ex.Message;
            }
        }
    }
}
