﻿using System;
using System.Collections.Generic;
using System.Text;
using iTextSharp.text;
using iTextSharp.text.rtf.parser;
using iTextSharp.text.pdf;
using System.IO;

namespace PDFUtilitiesOld
{
    class RTFToPDFConverter
    {
        public static string ConvertRTFToPDF(string filepath, string outputFile)
        {
            try
            {
                using (System.IO.FileStream sr = new System.IO.FileStream(filepath,FileMode.Open))
                {
                    Document pdfDoc = new Document(PageSize.A4, 10f, 10f, 10f, 0f);
                    RtfParser htmlparser = new RtfParser(pdfDoc);                    
                    
                    using (MemoryStream memoryStream = new MemoryStream())
                    {
                        PdfWriter writer = PdfWriter.GetInstance(pdfDoc, memoryStream);
                        pdfDoc.Open();

                        htmlparser.ConvertRtfDocument(sr, pdfDoc);
                        pdfDoc.Close();

                        byte[] bytes = memoryStream.ToArray();
                        memoryStream.Close();

                        System.IO.File.WriteAllBytes(outputFile, bytes);
                    }
                }

                return "";
            }
            catch (Exception ex)
            {
                return "Error-Count not Convert RTF to PDF " + System.IO.Path.GetFileName(filepath) + " " + ex.Message;
            }
        }
    }
}
