﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

using iTextSharp;
using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.text.factories;

using System.IO;
using System.Collections;

/*1
using PdfSharp.Drawing;
using PdfSharp.Pdf;
using PdfSharp.Pdf.IO;
using PdfSharp.Pdf.Advanced;
using PdfSharp.Pdf.Security;
*/


namespace UnlockPDF
{
    class UnlockPDFHelper
    {
        private static string err = "";

        public static string UnlockSinglePDF(string InputFile, string OutputFile, string Password)
        {
            string err = "";

            try
            {
                //                using (FileStream input = new FileStream(InputFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                //{
                PdfReader reader = null;

                if (!System.IO.Directory.Exists(System.IO.Path.GetDirectoryName(OutputFile)))
                {
                    try
                    {
                        System.IO.Directory.CreateDirectory(System.IO.Path.GetDirectoryName(OutputFile));
                    }
                    catch (Exception exd)
                    {
                        err += "Error. Could not Create Directory for File" + " : " + System.IO.Path.GetFileName(InputFile) + "\r\n" + exd.Message + "\r\n";

                        return err;
                    }
                }


                try
                {
                    //  reader = new PdfReader(input);

                    while (true)
                    {
                        using (Stream input = new FileStream(InputFile, FileMode.Open, FileAccess.Read, FileShare.Read))
                        {
                            try
                            {
                                if (!String.IsNullOrEmpty(Password))
                                {
                                    reader = new PdfReader(input, Encoding.Default.GetBytes(Password));
                                    //reader = new PdfReader(input, Encoding.UTF8.GetBytes(Password));

                                }
                                else
                                {
                                    reader = new PdfReader(input);
                                }

                                break;
                            }
                            catch (iTextSharp.text.pdf.BadPasswordException ex)
                            {
                                if (reader != null)
                                {
                                    reader.Close();
                                }

                                if (input != null)
                                {
                                    input.Close();
                                }
                                                                
                                    err += "Error. Wrong User Password for File" + " : " + System.IO.Path.GetFileName(InputFile);
                                    return err;                                                                                                
                            }
                        }
                    }                                        

                    using (MemoryStream memoryStream = new MemoryStream())
                    {
                        PdfStamper stamper = new PdfStamper(reader, memoryStream);

                        stamper.Close();
                        reader.Close();

                        File.WriteAllBytes(OutputFile, memoryStream.ToArray());

                        FixFileDates(OutputFile, InputFile);
                    }                    

                    return err;
                }
                catch (Exception exm)
                {
                    err += "An error occured while removing restrictions from PDF File" + " : " + System.IO.Path.GetFileName(InputFile) + "\r\n" + exm.Message + "\r\n";
                }
                finally
                {
                    if (reader != null)
                    {
                        reader.Close();
                    }
                }
            }
            catch (Exception ex)
            {
                err += "An error occured while removing restrictions from PDF File" + " : " + System.IO.Path.GetFileName(InputFile) + "\r\n" + ex.Message + "\r\n";
            }

            return err;
        }

        public static bool FixFileDates(string filepath, string originalFilepath)
        {
            System.IO.FileInfo fi = new System.IO.FileInfo(originalFilepath);

            System.IO.FileInfo fi2 = new System.IO.FileInfo(filepath);

            fi2.CreationTime = fi.CreationTime;
            fi2.CreationTimeUtc = fi.CreationTimeUtc;

            fi2.LastWriteTime = fi.LastWriteTime;
            fi2.LastWriteTimeUtc = fi.LastWriteTimeUtc;

            return true;
        }
    }
}
